﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using PowerLanguage;
using PowerLanguage.Indicator;

namespace PowerLanguage.Indicator
{
  public class Example
  {
    bool isLoaded;
    public Example()
    {
    }
    

    public double GetAvg(InstrumentDataRequest Request, DateTime From, DateTime To, IDataLoader loader)
    {
      double dResult = -1;

      Request.From = From;
      Request.To = To;
      Request.Resolution = new PowerLanguage.Resolution { Size = 1, Type = EResolution.Tick };

      IDataLoaderResult Result = loader.BeginLoadData( Request, CallBack, loader );
                                          
      DateTime Start = DateTime.Now;

      while (!Result.IsCompleted && Start > DateTime.Now.AddMinutes( -5 )) ;
        System.Threading.Thread.Sleep( 10 );

      if (Result.IsCompleted)
      {
        if (Result.Data.Length > 0)
        {
          foreach (Bar b in Result.Data)
          {
            dResult += b.Close;
          }
          dResult /= Result.Data.Length;
        }
      }

      return dResult;
    }

    void CallBack( IDataLoaderResult Result  )
    {
      IDataLoader loader = Result.State as IDataLoader;
      loader.EndLoadData( Result );
    }
   
  }
}
                        